// $Id: J4CAL.hh,v 1.1.1.2 2001/05/31 06:35:25 hoshina Exp $
#ifndef __J4CAL__
#define __J4CAL__
//*************************************************************************
//* --------------------
//* J4CAL
//* --------------------
//* (Description)
//* 	Derivation class for CAL.
//*     Mother class : J4VDetectorComponent
//*    
//* (Update Record)
//*	2000/12/08  K.Hoshina	Original version.
//*************************************************************************

#include "J4VCALDetectorComponent.hh"

//=====================================================================
//---------------------
// class definition
//---------------------

class J4CAL : public J4VCALDetectorComponent {	

public:
  J4CAL(J4VDetectorComponent *parent = 0,
  		     G4int nclones   = 1,
  		     G4int nbrothers = 1, 
  		     G4int me = 0);
  virtual ~J4CAL();

  virtual void	InstallIn(J4VDetectorComponent* mother)   ;
  virtual void	SwitchOn()  ;
  virtual void	SwitchOff() ;
  virtual void	Draw()      ;
  virtual void	Print() const ;
  
private:
  void 	Assemble();    
  void  Cabling ();
  
private:  
  static G4String	fName;
  
};

#endif


