// $Id: J4CDCLayer.hh,v 1.1.1.2 2001/05/31 06:35:25 hoshina Exp $
#ifndef __J4CDCLAYER__
#define __J4CDCLAYER__
//*************************************************************************
//* --------------------
//* J4CDCLayer
//* --------------------
//* (Description)
//* 	Derivation class for CDC Layer.
//*     Mother class : J4VDetectorComponent
//*    
//* (Update Record)
//*	2000/12/08  K.Hoshina	Original version.
//*************************************************************************

#include "J4CDCCell.hh"
#include "J4VCDCDetectorComponent.hh"

//=====================================================================
//---------------------
// class definition
//---------------------

class J4CDCLayer : public J4VCDCDetectorComponent {	

public:

  J4CDCLayer(J4VDetectorComponent* parent       = 0,
  	     G4int 		   nclones      = 1,
  	     G4int 		   nbrothers    = 1, 
  	     G4int 		   me           = 0   );
  	     
  J4CDCLayer(G4double 		   rmin, 		// Inner radius
  	     G4double 		   rmax,		// Outer radius
  	     G4double 		   len,			// Helf length along z-axis
  	     G4int    		   ncellclones,		// Number of clones of cell
  	     G4double 		   offset       = 0,	// Offcet azimutial angle
  	     J4VDetectorComponent* parent       = 0,
  	     G4int    		   nclones      = 1,
  	     G4int    		   nbrothers    = 1, 
  	     G4int    		   me           = 0  );
  	     
  virtual ~J4CDCLayer();

  virtual void	InstallIn(J4VDetectorComponent* mother)   ;
  virtual void	SwitchOn()  ;
  virtual void	SwitchOff() ;
  virtual void	Draw()      ;
  virtual void	Print() const ;
  
private:
  void 	Assemble();    
  void  Cabling ();
  
private:
  
  static G4String fName;
  J4CDCCell* fCell;
  
  G4double   fRmin;
  G4double   fRmax;
  G4double   fLen;
  G4double   fTotalPhi;
  G4double   fOffset;
  G4int      fNClonesOfCell; 
  
};

#endif


