// $Id: J4VSD.hh,v 1.1.1.2 2001/05/31 06:35:26 hoshina Exp $
#ifndef __J4VSD__
#define __J4VSD__
//*************************************************************************
//* --------------------
//* J4VSD
//* --------------------
//* (Description)
//* 	Abstract class template for his/her sensitive detector.
//*	You must use template class for derivation.
//*	Mother class : G4VSensitiveDetector
//*     
//* (Update Record)
//*	2001/02/18  K.Hoshina	Original version.
//*************************************************************************


//  !!! HOMEWORK !!!
//  Change a fHitBuf pointer to an fHitBuf* pointer array.
//  SensitiveDetector can have several HitBuffer class.

#include "J4VSensitiveDetector.hh"
#include "J4VDetectorComponent.hh"
#include "J4VHit.hh"
#include "G4HCofThisEvent.hh"
#include "G4THitsCollection.hh"

//=====================================================================
//---------------------
// class definition
//---------------------

class G4HCofThisEvent;

template <class HitType> 
class J4VSD : public J4VSensitiveDetector 
{ 

 public:
  J4VSD(J4VDetectorComponent* detector)
			: J4VSensitiveDetector(detector)
  {  
  }
  
  J4VSD(const J4VSD<G4THitsCollection<HitType> >& right)
		: J4VSensitiveDetector(right)
  {
  }
	
  virtual ~J4VSD()
  {
    if(GetHitBuf()) delete (G4THitsCollection<HitType>*)GetHitBuf();
    
    static G4int ncall = 0;
    G4cerr << "****** ~J4VSD ncall = " << ++ncall << " ********"<< G4endl;

  }

  
  virtual const J4VSD& operator=(const J4VSD<G4THitsCollection<HitType> >& right)
  {
    return (const J4VSD&)J4VSensitiveDetector::operator=(right);    
  } 
       
       
       
       
  virtual void MakeHitBuf(G4HCofThisEvent* HCTE)
  { 
  
//    G4cerr << "J4VSD::MakeHitBuf is called " << G4endl;  

    G4THitsCollection<HitType>* hitbuf; 
    hitbuf = new G4THitsCollection<HitType>(SensitiveDetectorName, collectionName[0]) ;
    SetHitBuf((void*)hitbuf);      
    G4int hcID = GetCollectionID(0); 
    HCTE->AddHitsCollection(hcID, (G4VHitsCollection*)GetHitBuf());
   
//    G4cerr << " ***hcID = " << hcID << G4endl;
     
  }  
  
  
  
  
  virtual void OutputAll(G4HCofThisEvent* HCTE)
  {  	
     if(GetHitBuf())
     {    	
       G4int nhits = ((G4THitsCollection<HitType>*)GetHitBuf())->entries();
       G4int i;
       
       G4cerr << "J4VSD::OutputAll: nhits = " << nhits << G4endl;

       for(i=0; i<nhits; i++)
       {
#if 1     	
     	  G4THitsCollection<HitType>* hcp = (G4THitsCollection<HitType>*)GetHitBuf();
     	  J4VHit* hp = (J4VHit*)hcp->operator[](i);
     	  hp->Output(HCTE);
#else     	
          ((J4VHit*)((G4THitsCollection<HitType>*)GetHitBuf())->operator[](i))->Output(HCTE);
#endif
       }
     }
     else
     {
//       G4cerr << "*****J4VSD::OutputAll: No Hit! " << G4endl;
     }
  }
  
    
  
  virtual void clear()
  {
#if 0
    if(GetHitBuf()) delete (G4THitsCollection<HitType>*)GetHitBuf();
#endif
  }

  virtual void DrawAll(){};
  virtual void PrintAll(){}; 

  // set/get functions
   
   

    
};


#endif
