// $Id: J4VVTXDetectorComponent.hh,v 1.1.1.2 2001/05/31 06:35:26 hoshina Exp $
#ifndef __J4VVTXDETECTORCOMPONENT__
#define __J4VVTXDETECTORCOMPONENT__
//*************************************************************************
//* -----------------------
//* J4VVTXDetectorComponent
//* -----------------------
//* (Description)
//* 	Class for describing his/her detector compornents.
//*     
//* (Update Record)
//*	2000/12/08  K.Hoshina	Original version.
//*************************************************************************

#include "J4VTXMaterialStore.hh"
#include "J4VDetectorComponent.hh"
#include "J4VTXParameter.hh"

//=====================================================================
//---------------------
// class definition
//---------------------

class J4VVTXDetectorComponent : public J4VDetectorComponent
{	// abstruct class

public:
  //default constructor...
  J4VVTXDetectorComponent( G4String& name, 
  			   J4VDetectorComponent *parent = 0,
  			   G4int nclones = 1,
  			   G4int nbrothers = 1, 
  			   G4int me = 0);
  			   
  virtual ~J4VVTXDetectorComponent();
#if 0 		          
  J4VVTXDetectorComponent(J4VVTXDetectorComponent& right);
  virtual const J4VVTXDetectorComponent& 
  		operator=(const J4VVTXDetectorComponent& right);    
#endif
      
protected:    
  J4VMaterialStore* 	 OpenMaterialStore();
  
private:
  static J4VTXMaterialStore* fMaterialStore;
  static G4String fSubGroup;
       
};

#if 0
//=====================================================================
//---------------------
// inline function
//---------------------


inline J4VVTXDetectorComponent::J4VVTXDetectorComponent(J4VVTXDetectorComponent& right)
{

  fMaterialStore = right.fMaterialStore;
  fSubGroup      = right.fSubGroup;
          
}

inline const J4VVTXDetectorComponent& 
J4VVTXDetectorComponent::operator=(const J4VVTXDetectorComponent& right)
{

  fMaterialStore = right.fMaterialStore;
  fSubGroup      = right.fSubGroup;
  
  return *this;
            
}

#endif



#endif


