// $Id: J4Beampipe.cc,v 1.1.1.2 2001/05/31 06:35:26 hoshina Exp $
//*************************************************************************
//* --------------------
//* J4Beampipe
//* --------------------
//* (Description)
//* 	Class for describing his/her detector compornents.
//*     
//* (Update Record)
//*	2000/12/08  K.Hoshina	Original version.
//*************************************************************************

#include "J4Beampipe.hh"


// ====================================================================
//--------------------------------
// constants (detector parameters)
//--------------------------------

G4String J4Beampipe::fName("Beampipe");

//=====================================================================
//---------------------
// Class Description
//---------------------

//=====================================================================
//* constructor -------------------------------------------------------

J4Beampipe::J4Beampipe(J4VDetectorComponent *parent,
			    G4int nclones,
  		  	    G4int nbrothers, 
  		  	    G4int me ) :
  		J4VBLDetectorComponent( fName, parent, nclones,
  					 nbrothers, me  ) 
{   
}

//=====================================================================
//* destructor --------------------------------------------------------

J4Beampipe::~J4Beampipe()
{
}

//=====================================================================
//* Assemble   --------------------------------------------------------

void J4Beampipe::Assemble() 
{   
  if(!GetLV()){
  	
    G4double rmin = _BPIR_;
    G4double rmax = _BPOR_;
    G4double len  = _BPLEN_;
    G4double dphi = _BPDPHI_;
  	
    // MakeSolid ----------//
    OrderNewTubs (rmin, rmax, len, dphi);
    
    // MakeLogicalVolume --//  
    MakeLVWith(OpenMaterialStore()->Order(_BPMATERIAL_));
    
    // SetVisAttribute ----//
    PaintLV(_BPVISATT_, G4Color(1, 0, 1));
  }
  	
    // Install daughter PV //
  		  
      
}

//=====================================================================
//* Cabling  ----------------------------------------------------------

void J4Beampipe::Cabling()
{
}

//=====================================================================
//* InstallIn  --------------------------------------------------------

void J4Beampipe::InstallIn(J4VDetectorComponent* mother)
{ 
  Assemble();			// You MUST call Assemble(); at first.
  				// 
  
  // Placement function into mother object...
  
  SetPVPlacement();
  
}


//* SwitchOn  --------------------------------------------------------
void J4Beampipe::SwitchOn()
{
}

//* SwitchOff  --------------------------------------------------------
void J4Beampipe::SwitchOff()
{
}

//* Draw  --------------------------------------------------------
void J4Beampipe::Draw()
{
  // set visualization attributes
  
}
	
//* Print  --------------------------------------------------------
void J4Beampipe::Print() const
{
}

	
	
