// $Id: J4VHit.cc,v 1.1.1.2 2001/05/31 06:35:26 hoshina Exp $
//*************************************************************************
//* --------------------
//* J4VHit
//* --------------------
//* (Description)
//* 	Abstruct hit class. This class also provide his
//*	proper HitCollection(buffering) class.
//*	Mother class : G4VHit
//*     
//* (Update Record)
//*	2001/03/15  K.Hoshina	Original version.
//*************************************************************************

#include <iomanip.h>
#include "J4VHit.hh"

ofstream* J4VHit::fOfs = 0;

//=========================================================================
//* constructor -----------------------------------------------------------

J4VHit::J4VHit()
	:fDetectorComponent(0), fTrackID(0), fParticle(0), 
	 fTof(0), fEnergyDeposit(0), fTotalEnergy(0),
	 fMomentum(0), fPrePosition(0), fPostPosition(0)
{ 
}

J4VHit::J4VHit( 
		J4VDetectorComponent* detector,   // He is in now
  	 	G4int		      cloneID,	  // CloneID of detector
		G4int		      trackID,	  // TrackID
		G4ParticleDefinition* particle,	  // particle
		G4double	      tof,	  // TOF 
		G4double 	      edep,	  // Energy Deposit
		G4double 	      totalE,	  // Total energy
		const G4ThreeVector&  p,	  // Momentum of perticle
 		const G4ThreeVector&  pre,	  // Pre-position of track
 		const G4ThreeVector&  pos )	  // Post-position of track
	:fDetectorComponent(detector), fTrackID(trackID), fParticle(particle), 
	 fTof(tof), fEnergyDeposit(edep), 
	 fTotalEnergy(totalE), fMomentum(p),
	 fPrePosition(pre), fPostPosition(pos)
{  
}


//=========================================================================
//* destructor -----------------------------------------------------------

J4VHit::~J4VHit()
{	
}

